Unit ALS1R2_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure ALS1R2(var A :Array of Real; M :Integer; N :Integer;
                var F :Array of Real);

implementation

procedure ALS1R2(var A :Array of Real; M :Integer; N :Integer;
                var F :Array of Real);
var
I,J,K :Integer;
H,R :Real;
const
ZERO :Real = 0.0;
label
_11,_12,_13,_14,_15,_16;
begin
{ ****************************************************C }
{        F1=Q*F, Q-     C }
{      ,  : D=Q*A*R.    C }
{ ****************************************************C }
if ( M < N ) or ( N <= 2 ) 
 then goto _16;
K := N;
if ( N-M ) < 0
 then goto _12
 else if ( N-M ) > 0
       then goto _16
       else goto _11;
_11:
K := K-1;
_12:
for J:=1 to K do
 begin
  if ( A[(J-1)+(J-1)*M] = ZERO ) 
   then goto _15;
  R := ZERO;
  for I:=J to M do
   begin
_13:
    R := R+F[I-1]*A[(I-1)+(J-1)*M];
   end;
  if ( R = ZERO ) 
   then goto _15;
  for I:=J to M do
   begin
_14:
    F[I-1] := F[I-1]-R*A[(I-1)+(J-1)*M];
   end;
_15:
 end;
_16:
end;

end.
